//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//
//       : main.c
//       : v2.0
//     : 2014-0101
//  ޸   : 
//     : OLED IICӿʾ(51ϵ)
//              ˵: 
//              ----------------------------------------------------------------
//              GND    Դ
//              VCC  5V3.3vԴ
//              D0   P1^0SCL
//              D1   P1^1SDA
//              RES  Ӹ
//              DC   ӵ
//              CS   ӵ                
//              ----------------------------------------------------------------
// ޸ʷ   :
//        : 
//All rights reserved
//******************************************************************************/
#include "reg52.h"
#define high 1
#define low 0 
/*************Pin Define***************/
sbit SCL=P1^0;
sbit SDA=P1^1;
/****************************************************/
void Initial_LY096BG30();
void Delay_50ms(unsigned int Del_50ms);
void Delay_1ms(unsigned int Del_1ms);
void fill_picture(unsigned char fill_Data);
void Picture_1();
void IIC_Start();
void IIC_Stop();
void Write_IIC_Command(unsigned char IIC_Command);
void Write_IIC_Data(unsigned char IIC_Data);
void Write_IIC_Byte(unsigned char IIC_Byte);
/***********************Initial code*********************/
void Initial_LY096BG30()
{
	Write_IIC_Command(0xAE);   //display off
	Write_IIC_Command(0x20);	//Set Memory Addressing Mode	
	Write_IIC_Command(0x10);	//00,Horizontal Addressing Mode;01,Vertical Addressing Mode;10,Page Addressing Mode (RESET);11,Invalid
	Write_IIC_Command(0xb0);	//Set Page Start Address for Page Addressing Mode,0-7
	Write_IIC_Command(0xc8);	//Set COM Output Scan Direction
	Write_IIC_Command(0x00);//---set low column address
	Write_IIC_Command(0x10);//---set high column address
	Write_IIC_Command(0x40);//--set start line address
	Write_IIC_Command(0x81);//--set contrast control register
	Write_IIC_Command(0x7f);
	Write_IIC_Command(0xa1);//--set segment re-map 0 to 127
	Write_IIC_Command(0xa6);//--set normal display
	Write_IIC_Command(0xa8);//--set multiplex ratio(1 to 64)
	Write_IIC_Command(0x3F);//
	Write_IIC_Command(0xa4);//0xa4,Output follows RAM content;0xa5,Output ignores RAM content
	Write_IIC_Command(0xd3);//-set display offset
	Write_IIC_Command(0x00);//-not offset
	Write_IIC_Command(0xd5);//--set display clock divide ratio/oscillator frequency
	Write_IIC_Command(0xf0);//--set divide ratio
	Write_IIC_Command(0xd9);//--set pre-charge period
	Write_IIC_Command(0x22); //
	Write_IIC_Command(0xda);//--set com pins hardware configuration
	Write_IIC_Command(0x12);
	Write_IIC_Command(0xdb);//--set vcomh
	Write_IIC_Command(0x20);//0x20,0.77xVcc
	Write_IIC_Command(0x8d);//--set DC-DC enable
	Write_IIC_Command(0x14);//
	Write_IIC_Command(0xaf);//--turn on oled panel 
}
/***********************Picture Code**************************/
unsigned char code show1[]=
{

0x00,0x80,0x08,0xD0,0x20,0x90,0x48,0x28,0x88,0x08,0x28,0xD0,0x00,0x00,0x00,0x00,
0x40,0xF8,0x40,0x40,0xF8,0x00,0x00,0xF0,0x00,0x00,0xF8,0x00,0x00,0x00,0x10,0x90,
0x90,0x90,0xF4,0x98,0x90,0x90,0x90,0x90,0x10,0x00,0x00,0x00,0x80,0xF0,0x0C,0x10,
0x10,0x10,0x90,0x70,0x18,0x00,0x00,0x00,0x00,0x00,0xF8,0xC8,0x38,0x08,0xF0,0x10,
0x10,0x10,0x10,0xF8,0x00,0x00,0x00,0x00,0x00,0xE0,0x20,0x20,0x20,0xFC,0x20,0x20,
0x20,0xE0,0x20,0x00,0x00,0x00,0x00,0x00,0x08,0x08,0x08,0x08,0xC8,0x28,0x18,0x08,
0x08,0x00,0x00,0x00,0x00,0x88,0x88,0x78,0x44,0x00,0x10,0x20,0x00,0xFC,0x04,0x00,
0x00,0x00,0x20,0x20,0xFC,0x20,0x20,0x20,0x20,0x20,0xFC,0x20,0x20,0x20,0x00,0x00,
0x00,0x00,0xFC,0x03,0x40,0x22,0x12,0x0E,0xFF,0x06,0x1A,0x22,0x03,0x00,0x00,0x20,
0x10,0x1F,0x90,0x68,0x1F,0x00,0x00,0x7F,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x7F,
0x00,0x00,0xFF,0x00,0x20,0x20,0x7F,0x00,0x00,0x00,0x00,0x03,0x00,0xFF,0x00,0x70,
0x8C,0x83,0x80,0x80,0x80,0x80,0x70,0x00,0x00,0x00,0xFF,0x00,0x11,0x0E,0x7F,0x41,
0x41,0x41,0x41,0xFF,0x00,0x00,0x00,0x00,0x00,0x1F,0x09,0x09,0x09,0xFF,0x89,0x89,
0x89,0x9F,0x80,0xE0,0x00,0x00,0x01,0x01,0x01,0x01,0x81,0x81,0x7F,0x01,0x01,0x01,
0x01,0x01,0x00,0x00,0x10,0x0C,0x03,0xFD,0x02,0x10,0x09,0x0A,0x08,0xFF,0x04,0x04,
0x00,0x00,0x04,0x82,0xFF,0x01,0x81,0x81,0x47,0x59,0x31,0x4D,0x83,0x80,0x00,0x00,
0x00,0x00,0x00,0x00,0x80,0x40,0x40,0x40,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x80,0x41,0x40,0x40,0x80,0x00,0x00,0x80,0x40,0x40,0x80,0x00,0x00,0x40,0x30,0x40,
0x30,0x00,0x80,0x40,0x40,0x40,0x80,0x00,0x40,0xC0,0x40,0x00,0x00,0x00,0x40,0xC0,
0x40,0x40,0xC0,0x00,0x40,0xC0,0x40,0x40,0x80,0x00,0x80,0x80,0xF0,0x80,0x20,0xA0,
0xF0,0xA0,0xF0,0xA0,0x20,0x00,0x80,0x40,0x30,0x80,0x00,0xE0,0x20,0x20,0x20,0xE0,
0x00,0x00,0x40,0x40,0xC0,0x40,0x40,0x00,0x40,0x40,0xC0,0x40,0x40,0x00,0x80,0x40,
0x40,0x40,0xC0,0x00,0x80,0x80,0xF0,0x80,0x40,0xC0,0x50,0x60,0x40,0xC1,0x40,0x00,
0x00,0xE0,0x20,0x20,0x20,0x21,0x20,0x20,0x20,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x1F,0x20,0x20,0x20,0x1F,0x00,0x00,0x20,0x00,0x00,0x00,0x00,
0x13,0x24,0x24,0x12,0x0F,0x00,0x1F,0x24,0x22,0x22,0x1C,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x1F,0x20,0x20,0x20,0x1F,0x00,0x20,0x3F,0x20,0x20,0x20,0x30,0x20,0x3F,
0x22,0x27,0x30,0x00,0x20,0x3F,0x20,0x20,0x1F,0x00,0x08,0x06,0xFF,0x04,0xA0,0xAF,
0x6A,0x3A,0x6A,0xAF,0xA0,0x00,0x49,0x4D,0x2B,0x28,0x80,0xFF,0x89,0x89,0x89,0xFF,
0x80,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x1F,0x20,
0x20,0x20,0x10,0x00,0x08,0x88,0xFF,0x04,0x8A,0xAA,0xBB,0x4E,0x4B,0xBA,0x8A,0x00,
0x00,0x7F,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0x00,
0x00,0x00,0x00,0x00,0x00,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xC0,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0xE0,0x00,0x00,0x00,0x00,
0x00,0x00,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x00,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,
0x00,0x00,0x80,0x80,0x80,0x80,0x80,0xC0,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0xFF,0xFC,
0xF8,0xF8,0xF8,0xF8,0xF8,0xFF,0xDF,0x1F,0x1F,0x1F,0x1F,0xFF,0xFF,0xF8,0xF0,0xF0,
0xF0,0xF0,0xF0,0xF8,0xFF,0xFF,0x1F,0x1F,0x1F,0x1F,0x1F,0xFF,0xF8,0xF8,0xF8,0xF8,
0xF8,0xF8,0xFF,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x00,0x00,0x00,0x00,
0x00,0x00,0x80,0x00,0x00,0x00,0xC0,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x80,
0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x88,0x49,0x29,0x19,0x0F,0x09,0xE9,0x09,0x0F,0x99,0x29,0x49,0x88,
0x00,0x80,0x80,0xBA,0xEA,0xAA,0xAA,0xAB,0xAA,0xAA,0xEA,0xBA,0x80,0x80,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x03,
0x03,0xFB,0xFB,0xFB,0xFB,0xFB,0xF9,0xF8,0xF8,0xF8,0xF8,0xFF,0xFF,0x1F,0x1F,0x1F,
0x1F,0x1F,0x1F,0x1F,0xFF,0xFF,0xF8,0xF8,0xF8,0xF8,0xF8,0xFB,0xFB,0xFB,0xFB,0xFB,
0x03,0x03,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x06,0x85,0x44,0x34,0xEE,0x25,0x24,0x24,0xA4,0x64,0x05,0x04,0x00,0xFF,0x00,
0xFE,0x00,0xFF,0x00,0x02,0x82,0x62,0x1A,0xFF,0x02,0x02,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x04,0x02,0x01,0x08,0x08,0x0F,0x01,0x06,0x00,0x01,0x06,0x00,
0x00,0x00,0x00,0x0E,0x0A,0x0A,0x0A,0x0A,0x0A,0x0A,0x0A,0x0E,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x02,0x01,0x08,0x08,0x08,0x04,0x05,0x02,0x05,0x04,0x08,0x08,0x08,0x00,0x08,0x06,
0x01,0x02,0x04,0x00,0x01,0x00,0x08,0x08,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,/*"C:\Users\Administrator\Desktop\0.96-1.bmp",0*/

};
/**********************************************
//IIC Start
**********************************************/
void IIC_Start()
{
   SCL = high;
   //Delay_us(1);		
   SDA = high;
   //Delay_us(1);
   SDA = low;
  // Delay_us(1);
   SCL = low;
  // Delay_us(1);
}

/**********************************************
//IIC Stop
**********************************************/
void IIC_Stop()
{
   SCL = low;
   //Delay_us(1);
   SDA = low;
   //Delay_us(1);
   SCL = high;
   //Delay_us(1);
   SDA = high;
   //Delay_us(1);
}
/**********************************************
// IIC Write byte
**********************************************/
void Write_IIC_Byte(unsigned char IIC_Byte)
{
	unsigned char i;
	for(i=0;i<8;i++)		
	{
		if(IIC_Byte & 0x80)		//1?0?
		SDA=high;
		else
		SDA=low;
		//Delay_us(1);
		SCL=high;
		//Delay_us(1);
		SCL=low;
		//Delay_us(1);
		IIC_Byte<<=1;			//loop
	}
	SDA=1;
	//Delay_us(1);
	SCL=1;
	//Delay_us(1);
	SCL=0;
	//Delay_us(1);
}
/**********************************************
// IIC Write Command
**********************************************/
void Write_IIC_Command(unsigned char IIC_Command)
{
   IIC_Start();
   Write_IIC_Byte(0x78);            //Slave address,SA0=0
   Write_IIC_Byte(0x00);			//write command
   Write_IIC_Byte(IIC_Command); 
   IIC_Stop();
}
/**********************************************
// IIC Write Data
**********************************************/
void Write_IIC_Data(unsigned char IIC_Data)
{
   IIC_Start();
   Write_IIC_Byte(0x78);			
   Write_IIC_Byte(0x40);			//write data
   Write_IIC_Byte(IIC_Data);
   IIC_Stop();
}
/********************************************
// fill_Picture
********************************************/
void fill_picture(unsigned char fill_Data)
{
	unsigned char m,n;
	for(m=0;m<8;m++)
	{
		Write_IIC_Command(0xb0+m);		//page0-page1
		Write_IIC_Command(0x00);		//low column start address
		Write_IIC_Command(0x10);		//high column start address
		for(n=0;n<128;n++)
			{
				Write_IIC_Data(fill_Data);
			}
	}
}
/******************************************
// picture
******************************************/
void picture_1()
{
  unsigned char x,y;
  unsigned int i=0;
  for(y=0;y<8;y++)
    {
      Write_IIC_Command(0xb0+y);
      Write_IIC_Command(0x00);
      Write_IIC_Command(0x10);
      for(x=0;x<128;x++)
        {
          Write_IIC_Data(show1[i++]);
        }
    }
}

/***********************Delay****************************************/
void Delay_50ms(unsigned int Del_50ms)		//
{
	unsigned int m;
	for(;Del_50ms>0;Del_50ms--)
		for(m=6245;m>0;m--);
}

void Delay_1ms(unsigned int Del_1ms)		//
{
	unsigned char j;
	while(Del_1ms--)
	{	
		for(j=0;j<123;j++);
	}
}
/*******************************Main*******************************/
void main(void)
{
			//
	Initial_LY096BG30();
	Delay_1ms(5);
	while(1)
	{
		fill_picture(0xff);	Delay_50ms(25);
		fill_picture(0xf0);	Delay_50ms(25);
		Picture_1();		Delay_50ms(25);
	}
}
